package com.fp.persistence.pgeneral.acco;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;

import com.fp.dto.hb.HibernateBean;

/** Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEACCONUMSTRUCTURE */
@Entity(name = "TgeneAccoNumStructure")
@Table(name = "TGENEACCONUMSTRUCTURE")
public class TgeneAccoNumStructure extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable {
    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;

    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;

    /**
     * Clave primaria de la Entidad TgeneAccoNumStructure
     */
    @EmbeddedId
    private TgeneAccoNumStructureKey pk;

    @Column(name = "SIZEFIELD", nullable = false)
    /**
     * Campo que almacena la longitud del campo que es parte del numero de cuenta
     */
    private Integer sizefield;

    @Column(name = "ORDERFIELD", nullable = false)
    /**
     * Campo que almacena el orden del campo que sera parte del numero de cuenta
     */
    private Integer orderfield;

    @Version
    @Column(name = "RECORDVERSION", nullable = true)
    /**
     * Optimistic locking del registro
     */
    private Integer recordversion;

    /** Contructor por defecto */
    public TgeneAccoNumStructure() {
    }

    /**
     * Contructor de TgeneAccoNumStructure
     * 
     * @param pPk Clave Primaria del entity
     * @param pSizefield Campo que almacena la longitud del campo que es parte del numero de cuenta
     * @param pOrderfield Campo que almacena el orden del campo que sera parte del numero de cuenta
     */
    public TgeneAccoNumStructure(TgeneAccoNumStructureKey pPk, Integer pSizefield, Integer pOrderfield) {
        this();
        this.pk = pPk;
        this.sizefield = pSizefield;
        this.orderfield = pOrderfield;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     * 
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TgeneAccoNumStructure
     */
    public static TgeneAccoNumStructure find(EntityManager pEntityManager, TgeneAccoNumStructureKey pKey) throws Exception {
        TgeneAccoNumStructure obj = pEntityManager.find(TgeneAccoNumStructure.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TgeneAccoNumStructure
     * 
     * @return El objeto que referencia a la Clave primaria de TgeneAccoNumStructure
     */
    public TgeneAccoNumStructureKey getPk() {
        return this.pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TgeneAccoNumStructure
     * 
     * @param pPk El objeto que referencia a la nueva Clave primaria de TgeneAccoNumStructure
     */
    public void setPk(TgeneAccoNumStructureKey pPk) {
        this.pk = pPk;
    }

    /**
     * Obtiene el valor de sizefield
     * 
     * @return valor de sizefield
     */
    public Integer getSizefield() {
        return this.sizefield;
    }

    /**
     * Fija el valor de sizefield
     * 
     * @param pSizefield nuevo Valor de sizefield
     */
    public void setSizefield(Integer pSizefield) {
        this.sizefield = pSizefield;
    }

    /**
     * Obtiene el valor de orderfield
     * 
     * @return valor de orderfield
     */
    public Integer getOrderfield() {
        return this.orderfield;
    }

    /**
     * Fija el valor de orderfield
     * 
     * @param pOrderfield nuevo Valor de orderfield
     */
    public void setOrderfield(Integer pOrderfield) {
        this.orderfield = pOrderfield;
    }

    /**
     * Obtiene el valor de recordversion
     * 
     * @return valor de recordversion
     */
    public Integer getRecordversion() {
        return this.recordversion;
    }

    /**
     * Fija el valor de recordversion
     * 
     * @param pRecordversion nuevo Valor de recordversion
     */
    public void setRecordversion(Integer pRecordversion) {
        this.recordversion = pRecordversion;
    }

    @Override
    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TgeneAccoNumStructure)) {
            return false;
        }
        TgeneAccoNumStructure that = (TgeneAccoNumStructure) rhs;
        if ((this.getPk() == null) || (that.getPk() == null)) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementación del metodo hashCode de la la entidad TgeneAccoNumStructure
     * 
     * @return el hashCode la instancia
     */
    @Override
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /** Implementación toString */
    @Override
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if ((name.compareTo("hashValue") == 0) || (name.compareTo("serialVersionUID") == 0)) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /** Implementación de la creación de un bean en blanco TgeneAccoNumStructure */
    @Override
    public Object createInstance() {
        TgeneAccoNumStructure instance = new TgeneAccoNumStructure();
        instance.setPk(new TgeneAccoNumStructureKey());
        return instance;
    }

    /**
     * Clona la entidad TgeneAccoNumStructure
     * 
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    @Override
    public Object cloneMe() throws CloneNotSupportedException {
        TgeneAccoNumStructure p = (TgeneAccoNumStructure) this.clone();
        p.setPk((TgeneAccoNumStructureKey) this.pk.cloneMe());
        return p;
    }

    // METODOS MANUALES
    /**
     * Sentencia que obtiene un registro de TgeneAccoNumStructure con la definicion de estructura para crear un numero
     * de cuenta.
     */
    private static final String JPQL = "from TgeneAccoNumStructure t " + " where t.pk.modulecode = :modulecode order by t.orderfield";

    /**
     * Metodo que entrega la defincion de una cuenta por modulo.
     * 
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pModule Codigo de modulo
     * @return TgeneAccountSequence
     */
    @SuppressWarnings("unchecked")
    public static List<TgeneAccoNumStructure> find(EntityManager pEntityManager, String pModule) throws Exception {
        Query qry = pEntityManager.createQuery(TgeneAccoNumStructure.JPQL);
        qry.setParameter("modulecode", pModule);
        return qry.getResultList();
    }

}
